﻿using System;
using System.Threading.Tasks;
using Flurl;
using Flurl.Http;

namespace UDFUpdater.APIClient.Endpoints
{
    public class UserDefinedFieldTypes
    {
        private readonly Url _baseRequest;
        private readonly string _apiKey;

        public UserDefinedFieldTypes(Url baseRequest, string apiKey)
        {
            _baseRequest = baseRequest;
            _apiKey = apiKey;
        }
        
	
        public Task<QueryResultsContainer<UserDefinedFieldType>> List(){
            return _baseRequest
                .WithIssuetrakAuthentication(_apiKey)
                .AppendPathSegments("userdefinedfieldtypes")
                .WithHeader("X-IssueTrak-API-Request-ID", Guid.NewGuid())
                .GetJsonAsync<QueryResultsContainer<UserDefinedFieldType>>();
        }

    }

    public class UserDefinedFieldType
    {
        public int UserDefinedFieldId {get;set;}
        public int UserDefinedKeyId {get;set;}
        public string DisplayName { get; set; } = string.Empty;
        public bool IsPrivate {get;set;}
        public int TextDisplayWidth {get;set;}
    }
}