﻿using System;
using Flurl;
using Flurl.Http;
using UDFUpdater.APIClient.Endpoints;

namespace UDFUpdater.APIClient
{
    public class IssuetrakApiClient
    {
        private readonly string _apiKey;
        private readonly Url _baseRequest;
		
        public IssuetrakApiClient(string baseUrl, string apiKey)
            :this(new Url(baseUrl), apiKey){}

        public IssuetrakApiClient(Uri baseUrl, string apiKey)
            :this(new Url(baseUrl), apiKey){}

	    public IssuetrakApiClient(Url baseUrl, string apiKey){
            if (baseUrl == null)
            {
				throw new ArgumentNullException(nameof(baseUrl));
            }

            _apiKey = apiKey;
            _baseRequest = baseUrl
			    .AppendPathSegments("api","v1");
	    }
	    
	    public Issues Issues => new Issues(_baseRequest, _apiKey);
        public UserDefinedFieldTypes UdfTypes => new UserDefinedFieldTypes(_baseRequest, _apiKey);
    }
}
