﻿using System;
using System.Collections.Generic;

namespace UDFUpdater.APIClient.Models
{
    public class ReadIssue
    {

        public int IssueNumber { get; set; }
        public string Subject { get; set; } = string.Empty;
        public string Description { get; set; } = string.Empty;
        public bool IsDescriptionRichText { get; set; }
        public int? IssueTypeId { get; set; }
        public int? IssueSubTypeId { get; set; }
        public int? IssueSubType2Id { get; set; }
        public int? IssueSubType3Id { get; set; }
        public int? IssueSubType4Id { get; set; }
        public int? PriorityId { get; set; }
        public int? AssetNumber { get; set; }
        public string? LocationId { get; set; }
        public string SubmittedBy { get; set; } = string.Empty;
        public string? AssignedTo { get; set; }
        public DateTime? TargetDate { get; set; }
        public DateTime? RequiredByDate { get; set; }
        public string? NextActionTo { get; set; }
        public int? SubStatusId { get; set; }
        public int? ProjectId { get; set; }
        public int? OrganizationId { get; set; }
        public bool? ShouldNeverSendEmailForIssue { get; set; }
        public int? ClassId { get; set; }
        public int? DepartmentId { get; set; }
        public string SpecialFunction1 { get; set; } = string.Empty;
        public string SpecialFunction2 { get; set; } = string.Empty;
        public string SpecialFunction3 { get; set; } = string.Empty;
        public string SpecialFunction4 { get; set; } = string.Empty;
        public string SpecialFunction5 { get; set; } = string.Empty;
        public string IssueSolution { get; set; } = string.Empty;
        public string Status { get; set; } = string.Empty;
        public string ClosedBy { get; set; } = string.Empty;
        public DateTime? ClosedDate { get; set; }
        public int? CauseId { get; set; }
        public int? SeverityId { get; set; }
        public DateTime? ResponseTime { get; set; }
        public bool? IsFirstCallResolution { get; set; }
        public IEnumerable<ReadUserDefinedField> UserDefinedFields { get; set; } = new List<ReadUserDefinedField>();

    }

    public class ReadUserDefinedField
    {
        public int IssueNumber { get; set; }
        public string DisplayName { get; set; } = string.Empty;
        public int UserDefinedFieldId { get; set; }
        public string Value { get; set; } = string.Empty;

    }

}