(function()
{
    // This example creates a note on an issue by calling the notes API end point.
    
    var uuid = require("node-uuid"); // Used to create Request Id required by API.
    var library = require("./IssueTrak.API.NodeJS.Example.Library"); // Functions used by this client.

    var apiKey = "dGhpc2lzbnRyZWFsbHlhbmFwaWtleQ="; // API Key.
    var server = "servername"; // Server name part of the URL to the API.
    var port = 80; // Port the API is using.
    var absolutePath = "/sitetoplevel/api/v1/notes"; // path part of the URL to API (does not include schema ("http://"), server ("local.issuetrak.com") or query portion ("?color=blue&number=5").
    var httpVerb = "POST"; // Http verb to use ("GET", "POST", etc.).
    var requestId = uuid.v1().toLowerCase(); // Request Id.
    var timestamp = new Date().toISOString().replace("Z", "0000Z"); // Timestamp with 7 digits fractional seconds precision.  The .toISOString function only gives 3 digits precision.
    var query = ""; // Query portion of URL to API (e.g. "?issueNumbers=17485%2C17486%2C17487" - %2C is a URL encoded comma).

    //var body = "{\"IssueNumber\":17127,\"CreatedDate\":\"2015-03-31T13:31:52.0000455Z\",\"IsRichText\":false,\"IsPrivate\":true,\"CreatedBy\":\"rquatt\",\"NoteText\":\"Test 5: API called by NodeJS.\",\"ShouldSuppressEmailForCreateOperation\":false}"; // The body of the request.
    var noteModel =
    {
        "IssueNumber": 1,
        "CreatedDate": "2015-04-02T15:57:52.0000455Z",
        "IsRichText": false,
        "IsPrivate": true,
        "CreatedBy": "admin",
        "NoteText": "This note (2) was created from a NodeJS application calling the API using JSON serialization on a JavaScript object.",
        "ShouldSuppressEmailForCreateOperation": true
    };
    var body = JSON.stringify(noteModel);

    // Put together the authorization text required by the API.
    var authorization = httpVerb + "\n"
                      + requestId + "\n"
                      + timestamp + "\n"
                      + absolutePath + "\n"
                      + query + "\n"
                      + body;

    // Encrypt the authorization text using sha512 and base64.
    var authorizationHash = library.Encrypt(apiKey, authorization);
    console.log(authorizationHash);
    
    // Put the HTTP request headers required by the API together.
    var headers = library.MakeHeaders(requestId, timestamp, authorizationHash, body.length);
    
    // Make the HTTP call to the API.
    library.CallAPI(httpVerb, server, port, absolutePath, headers, body, function(response)
    {
        // Parse the text response from the server (JSON) to a JavaScript object.
        var data = JSON.parse(response);
        console.log(data); // data should be the id of the note created, or an error message if something went wrong.
    });
    
})();
